%option nounput backup nostdinit noyywrap
%option 8bit backup
%option prefix="help"
%x ENTRY
%{
#include <unistd.h>
#include "config.h"
%}

%%
	struct symbol *sym = NULL;
	helpin = fopen("Configure.help", "r");
	if (!helpin) {
		printf("can't open Configure.help!\n");
		exit(1);
	}

^#.*\n	/* skip */

^CONFIG_[[:alnum:]_]+ {
	char name[256];
	int ch;
	while ((ch = input()) != '\n' && ch != EOF)
		;
	memcpy(name, yytext, yyleng);
	name[yyleng] = 0;
	sym = lookup_symbol(name, SYMBOL_UNKNOWN);
	new_string();
	BEGIN(ENTRY);
}

<ENTRY>{
	[ \t].*\n+/[^ \t\n] {
		append_string(yytext, yyleng);
		if (sym) {
			if (sym->help) {
				//printf("symbol %s has duplicated help?\n", sym->name);
				free(text);
			} else
				sym->help = text;
			sym = NULL;
		} else
			printf("no symbol?\n");
		BEGIN(INITIAL);
	}
	[ \t].*\n |
	\n	{
		append_string(yytext, yyleng);
	}
}

.
\n
%%
